<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="年份" prop="year">
        <el-select v-model="queryParams.year" placeholder="请选择年份" >
          <el-option
            v-for="year in yearList"
            :key="year"
            :label="year"
            :value="year"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-select v-model="queryParams.month" placeholder="请选择月份" >
          <el-option label="11" value="shanghai"></el-option>
          <el-option label="12" value="beijing"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="州市" prop="cityName">
        <el-select v-model="queryParams.cityName" placeholder="请选择州市" >
          <el-option
            v-for="region in regionOptions"
            :key="region.cityShortName"
            :label="region.cityShortName"
            :value="region.code"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置/刷新</el-button>
      </el-form-item>
    </el-form>

    <div id="scrollTable">
      <el-table v-loading="loading" :data="rzgViewStatisticsInfoList" :max-height="maxHeight" :header-cell-style="{background:'#2a8eed',color:'#fafcfe',}">
        <el-table-column label="地区" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{scope.row.datas[0]}}</span>
          </template>
        </el-table-column>
        <el-table-column label="专利类型" align="center" width="100" fixed="left">
          <template slot-scope="scope">
            <span>{{scope.row.datas[1]}}</span>
          </template>
        </el-table-column>
        <el-table-column :label="hearderTitle" align="center">
          <el-table-column v-for="(item,index) in headerList" :label="item.patentName" align="center" :key="index">
            <template slot-scope="scope">
              <span>{{scope.row.datas[index+2]}}</span>
            </template>
          </el-table-column>
        </el-table-column>
      </el-table>
    </div>


  </div>
</template>

<script>
import { listRzgViewStatisticsInfo, getRzgViewStatisticsInfo, delRzgViewStatisticsInfo, addRzgViewStatisticsInfo, updateRzgViewStatisticsInfo } from "@/api/reportpub/rzgViewStatisticsInfo";
import {listUrPatentValid, getHeaderList, getYearList, getRegionList} from "@/api/system/urPatentValid";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
export default {
  name: "RzgViewStatisticsInfo",
  data() {
    return {

      maxHeight: 0,
      hearderTitle:'统计时期2023-1',
      headerList: [],
      // 查询年份数据
      yearList: [],
      regionOptions: [],

      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 专利公开-概况统计表格数据
      rzgViewStatisticsInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
          pageNum: 1,
          pageSize: 10,
        cityCode: null,
        cityName: null,
        year: '',
        month: null,
        patentType: null,
        higherSchool: null,
        researchInstitute: null,
        enterprise: null,
        institutions: null,
        individual: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getYear();
    this.getRegion();
    this.getHeader();
    this.getList();

    this.$nextTick(()=>{
      this.maxHeight = window.innerHeight - 200;//300是页面中除了表格外其他组件的高度
    })
  },
  methods: {


    /** 获取省市列表 */
    getRegion() {
      let params = {};
      getRegionList(params).then(response => {
        this.regionOptions = response.data;
      });
    },
    handerMethod ({ row, column, rowIndex, columnIndex }) {
      // if (rowIndex === 0) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         this.$nextTick(() => {
      //             var _c = document.getElementsByClassName(column.id);
      //             document.getElementsByClassName(column.id)[0].setAttribute('rowSpan', 2);
      //         });
      //         return column;
      //     }
      // } else if (rowIndex === 1) {
      //     if (column.label == '地区' || column.label == '专利类型') {
      //         return { display: 'none' };
      //     }
      // }
      // if (column[0].level == 1) {
      //     column[0].rowSpan = 2
      //     column[1].rowSpan = 0
      //     if (rowIndex === 1) {
      //         return { display: 'none' }
      //     }
      // }
    },

    /** 获取动态表头 */
    getHeader() {
      this.queryParams.startDate = this.queryParams.year;
      getHeaderList(this.queryParams).then(response => {
        this.headerList = response.data;
      });
    },
    /** 获取查询年份列表 */
    getYear() {
      getYearList().then(response => {
        this.yearList = response.data;
      });
    },

    /** 查询专利公开-概况统计列表 */
    getList() {
      this.loading = true;
      listRzgViewStatisticsInfo(this.queryParams).then(response => {
        this.rzgViewStatisticsInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        cityCode: null,
        cityName: null,
        year: null,
        month: null,
        patentType: null,
        higherSchool: null,
        researchInstitute: null,
        enterprise: null,
        institutions: null,
        individual: null,
        remark: null,
        delFlag: null,
        status: 0,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getHeader();
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加专利公开-概况统计";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRzgViewStatisticsInfo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改专利公开-概况统计";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateRzgViewStatisticsInfo(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRzgViewStatisticsInfo(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除专利公开-概况统计编号为"' + ids + '"的数据项？').then(function() {
        return delRzgViewStatisticsInfo(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('reportpub/rzgViewStatisticsInfo/export', {
        ...this.queryParams
      }, `rzgViewStatisticsInfo_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>


<style rel="stylesheet/scss" lang="scss" scoped>


  // ----------修改elementui表格的默认样式-----------
  .el-table__body-wrapper {
    &::-webkit-scrollbar { // 整个滚动条
      width: 0; // 纵向滚动条的宽度
      background: rgba(213,215,220,0.3);
      border: none;
    }
    &::-webkit-scrollbar-track { // 滚动条轨道
      border: none;
    }
  }

  // --------------------隐藏table gutter列和内容区右侧的空白 start
  .el-table th.gutter{
    display: none;
    width:0
  }
  .el-table colgroup col[name='gutter']{
    display: none;
    width: 0;
  }

  .el-table__body{
    width: 100% !important;
  }

  // --------------------隐藏table gutter列和内容区右侧的空白 end
</style>


